/**
 * User: John Lindquist
 * Date: Aug 31, 2010
 * Time: 2:24:01 AM
 */
package patterncraft.raven
{
	import patterncraft.move.Fly;
	import patterncraft.tank.*;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.TimerEvent;
	import flash.utils.Timer;


	internal class FlyState extends EventDispatcher implements IRavenState {
        private var raven:Raven;

        public function FlyState(raven:Raven) {
            this.raven = raven;
        }

        public function get damage():Number { return 20; }

        public function get canMove():Boolean { return false; }

        public function get color():uint { return 0x00cc00; }

		public function apply():void {
			raven.mouseEnabled = true;
			raven.alpha = 1;

			raven.moveBehavior = new Fly();
		}

		public function transitionTo(state:String):void {
			raven.mouseEnabled = false;
			raven.alpha = 0.3;
			raven.moveBehavior = null;

			var timer:Timer = new Timer(1000, 1);
			timer.addEventListener(TimerEvent.TIMER, onTransitionComplete);
			timer.start();
		}

		private function onTransitionComplete(event:TimerEvent):void {
			event.currentTarget.reset();
			dispatchEvent(new Event(Event.COMPLETE));
		}
    }
}